<template>
  <main>
    <mt-page-title :with-border="false" :with-padding="true">
      <h1 class="has-text-weight-bold is-size-3">Statistiques</h1>
    </mt-page-title>
    <mt-box padding="0">
      <b-tabs v-model="onglet" class="mt-box-onglet ">
        <b-tab-item label="Générales">
          <section class="statistiques columns">
            <mt-stat-nombre icon="flag" :valeur="statistiques.organismes">
              Organismes
            </mt-stat-nombre>
            <mt-stat-nombre icon="account" :valeur="statistiques.utilisateurs">
              Utilisateurs actifs
            </mt-stat-nombre>
            <mt-stat-nombre icon="email" :valeur="statistiques.invitations">
              Invitations
            </mt-stat-nombre>

            <mt-stat-nombre icon="clipboard-text" :valeur="statistiques.activites">
              Activités
            </mt-stat-nombre>
            <mt-stat-nombre icon="clipboard-account" :valeur="statistiques.participations">
              Participations
            </mt-stat-nombre>
            <mt-stat-nombre icon="calendar" :valeur="statistiques.disponibilites">
              Disponibilités <mt-disponibilite-puce is-disponible />
            </mt-stat-nombre>
          </section>
        </b-tab-item>
        <b-tab-item label="Organismes">
          <article class="mt-box-content">
            <form @submit.prevent="moisSelectionne">
              <b-message type="is-danger" size="is-small" class="is-size-7" :active="dateInError">
                La date de fin est antérieure à la date de début
              </b-message>
              <section class="mt-fields-section columns">
                <b-field label="Début de la période" class="column is-one-third">
                  <b-datepicker
                    v-model="start"
                    placeholder="Sélectionnez une date de debut"
                    :first-day-of-week="1"
                    :month-names="monthNames"
                    :day-names="dayNames"
                    :date-parser="dateParse"
                    editable
                    icon="calendar-today"
                    class="mt-input"
                    @input="moisSelectionneDebut"
                  />
                </b-field>

                <b-field label="Fin de la période" class="column is-one-third">
                  <b-datepicker
                    v-model="end"
                    placeholder="Sélectionnez une date de fin"
                    :first-day-of-week="1"
                    :month-names="monthNames"
                    :day-names="dayNames"
                    :date-parser="dateParse"
                    editable
                    icon="calendar-today"
                    class="mt-input"
                    @input="moisSelectionneFin"
                  />
                </b-field>
              </section>
            </form>
            <mt-list v-slot="{ item: stat }" :list="statistiqueDispoOrganisme">
              <mt-list-item>
                <div class="columns is-vcentered">
                  <div class="column cursor-as-default">
                    <nuxt-link
                      :to="
                        profilLink({
                          name: 'dashboard-statistiques-id-utilisateurs',
                          params: { id: stat.id },
                          query: { start: queryStart, end: queryEnd },
                        })
                      "
                    >
                      <span
                        ><small class="cursor-as-default">{{ stat.codeParent }}</small> / <b>{{ stat.code }}</b></span
                      >
                    </nuxt-link>
                  </div>
                  <div
                    class="column is-narrow is-size-7 cursor-as-default"
                    :title="`${stat.nbUtilisateur} utilisateurs`"
                  >
                    {{ stat.nbUtilisateur }}
                    <b-icon icon="account" size="is-small"></b-icon>
                  </div>
                  <div
                    class="column is-narrow is-size-7 cursor-as-default"
                    :title="`${stat.nbTokenInvitation} invitations`"
                  >
                    {{ stat.nbTokenInvitation }}
                    <b-icon icon="email" size="is-small"></b-icon>
                  </div>
                  <div class="column is-narrow is-size-7 cursor-as-default" :title="`${stat.nbActivites} activités`">
                    {{ stat.nbActivites }}
                    <b-icon icon="clipboard-text" size="is-small"></b-icon>
                  </div>
                  <div
                    class="column is-narrow is-size-7 cursor-as-default"
                    :title="`${stat.nbDisponibilite} jours ayant des disponibilités (disponible ou indisponible)`"
                  >
                    {{ stat.nbDisponibilite }}
                    <b-icon icon="calendar" size="is-small"></b-icon>
                  </div>
                  <div
                    class="column is-narrow is-size-7 cursor-as-default"
                    :title="`${stat.nbDisponibiliteOk} jours disponibles`"
                  >
                    {{ stat.nbDisponibiliteOk }}
                    <mt-disponibilite-puce is-disponible />
                  </div>
                  <div
                    class="column is-2 is-size-7 cursor-as-default"
                    :title="`Taux de remplissage des disponibilités sur ${stat.nbJours} j`"
                  >
                    <mt-stat-dispo :pourcentage="stat.remplissageDispo.pourcentage" />
                  </div>
                </div>
              </mt-list-item>
            </mt-list>
          </article>
        </b-tab-item>
        <b-tab-item label="Dernières Connexions">
          <mt-list v-slot="{ item: stat }" :list="dernieresConnexions">
            <mt-list-item>
              <div class="columns is-vcentered">
                <div class="column cursor-as-default">
                  <mt-utilisateur :utilisateur="stat.utilisateur" />
                  <time title="Dernière connexion">{{ dateFormatter(stat.derniereConnexion) }}</time>
                </div>
                <div class="column cursor-as-default">
                  {{ stat.utilisateur.affectation.organisme.codeParent }} /
                  <b>{{ stat.utilisateur.affectation.organisme.code }}</b>
                </div>
              </div>
            </mt-list-item>
          </mt-list>
        </b-tab-item>
      </b-tabs>
    </mt-box>
  </main>
</template>

<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtBox from '~/components/base/box';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';
import { statistiqueMixin } from '~/components/mixins/statistiqueMixin';
import MtStatDispo from '~/components/statistique/mt-stat-dispo';
import MtStatNombre from '~/components/statistique/mt-stat-nombre';
import MtUtilisateur from '~/components/pax/mt-utilisateur';

export default {
  components: {
    MtUtilisateur,
    MtStatNombre,
    MtStatDispo,
    MtDisponibilitePuce,
    MtPageTitle,
    MtList,
    MtListItem,
    MtBox,
  },
  mixins: [DayMonthMixin, statistiqueMixin],
  computed: {
    queryStart() {
      return DateTime.fromJSDate(this.start).toFormat('dd/MM/yyyy', { locale: 'fr' });
    },
    queryEnd() {
      return DateTime.fromJSDate(this.end).toFormat('dd/MM/yyyy', { locale: 'fr' });
    },
  },
  async asyncData({ $api, query }) {
    const moisCourant = new Date();
    const start =
      query && query.start
        ? DateTime.fromFormat(query.start, 'dd/MM/yyyy', { locale: 'fr' })
        : DateTime.fromJSDate(moisCourant).startOf('month');

    const end =
      query && query.end
        ? DateTime.fromFormat(query.end, 'dd/MM/yyyy', { locale: 'fr' })
        : DateTime.fromJSDate(moisCourant).endOf('month');

    start.set({ hour: 8 });
    start.set({ hour: 18 });

    // sans parseInt l'onglet n'est pas bien selectionné.
    const onglet = parseInt(query && query.onglet ? query.onglet : 0, 10);

    const [statistiqueDispoOrganisme, statistiques, dernieresConnexions] = await Promise.all([
      $api.statistiques.organisme(start.toISO(), end.toISO()),
      $api.statistiques.generales(),
      $api.statistiques.dernieresConnexion(),
    ]);

    return {
      start: start.toJSDate(),
      end: end.toJSDate(),
      statistiqueDispoOrganisme,
      statistiques,
      dernieresConnexions,
      onglet,
    };
  },
  mounted() {},
  methods: {
    async moisSelectionneDebut() {
      this.start.setHours(8);
      this.end.setHours(18);
      if (this.start > this.end) {
        this.end = this.start;
      }
      this.statistiqueDispoOrganisme = await this.$api.statistiques.organisme(
        this.start.toISOString(),
        this.end.toISOString(),
      );
      await this.$router.replace({
        query: {
          start: this.queryStart,
          end: this.queryEnd,
        },
      });
    },
    async moisSelectionneFin() {
      this.start.setHours(8);
      this.end.setHours(18);
      if (this.end < this.start) {
        this.start = this.end;
      }
      this.statistiqueDispoOrganisme = await this.$api.statistiques.organisme(
        this.start.toISOString(),
        this.end.toISOString(),
      );
      await this.$router.replace({
        query: {
          start: this.queryStart,
          end: this.queryEnd,
        },
      });
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-filter-liste {
  margin-top: 1rem;
}
footer {
  padding: 0.5rem 0;
  margin-bottom: 1rem;
}
.mt-pourcentage {
  display: inline-flex;
  color: white;
  border-radius: 2em;
  padding: 0.2em 0.7em;

  &-red {
    background-color: $red;
  }
  &-orange {
    background-color: $orange;
  }
  &-yellow {
    background-color: $yellow;
  }
  &-green {
    background-color: $green;
  }
}
.cursor-as-default {
  cursor: default;
}
.mt-list {
  .column.is-narrow {
    padding: 0 0.8rem;
  }
}
.statistiques {
  padding: 1rem 1.25rem;
  margin-bottom: 2rem;
  flex-wrap: wrap;
  justify-content: center;
  align-items: center;
}
time {
  font-size: 0.75rem;
  color: $grey-light;
  font-style: italic;
}
</style>
